#!/bin/bash
#	$Id: dump_full.sh 2276 2005-10-10 18:18:43Z jeff $
#	$Author: jeff $
#	Create full FreeMED dump

PHYSICAL="$(scripts/cfg-value PHYSICAL_LOCATION)"

if [ ! -d "${PHYSICAL}" ]; then
	echo "Could not find FreeMED!"
	exit -1
fi

mysqldump \
	--single-transaction \
	--user="$(scripts/cfg-value DB_USER)" \
	--password="$(scripts/cfg-value DB_PASS)" \
	freemed > data/backup/full
